/* src/showcommands.c - Liste les commandes
 * Copyright (C) 2002-2003 Inter System (Progs@Inter-System.Net)
 *
 * contact: Progs@Inter-System.Net
 *          Cesar@Inter-System.Net
 *          kouak@kouak.org
 * site web: http://coderz.inter-system.net
 *
 * Services pour serveur IRC. Support sur IrcProgs et IrCoderZ
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <main.h>

CVSINFO("$Id: showcommands.c,v 1.5 2003/03/09 09:14:55 romexzf Exp $");

extern struct cs_commands cs_cmds[];

void showcommands(aNick *nick, aChan *chaninfo, int parc, char **parv)
{
	char cmds[150];
	anAccess *access;
	int level, premier, j, maxlevel=0;

	if(nick->user)
	{
		if(IsAnAdmin(nick->user)) maxlevel = 500;
		else for(access = nick->user->accesshead;access;access = access->next)
			if(maxlevel < access->level) maxlevel = access->level;
	}
	else maxlevel = 0;

	for(level = 0; level<=500; level++)
	{
		if(!level || (level >= 5 && level <= maxlevel) || (nick->user && level < 5 && nick->user->level >= level))
		{
			premier = 1;
			cmds[0]='\0';
			for(j = 0;cs_cmds[j].cmd[0] != '\0';j++)
			{
				if(cs_cmds[j].level == level && cs_cmds[j].cmd[0] != CTCP_DELIM_CHAR && !cs_cmds[j].disable)
				{
					strcat(cmds, " ");
					strcat(cmds, cs_cmds[j].cmd);
					if(strlen(cmds) > 80)
					{
						if(premier)
						{
							premier=0;
							if(level == 2)
								csntc(nick, "------------------[ \0036Commandes \002\0034Admins\003\002 ]------------------");
							else if(!level)
								csntc(nick, "------------------[ \0036Commandes \002\0033Users\003\002  ]------------------");
							else if(level == 5)
								csntc(nick, "------------------[ \0036Commandes \002\0032Salons\003\002 ]------------------");
							csntc(nick, "\002Niveau %3d:\002%s", level, cmds);
							cmds[0]='\0';
						}
						else
						{
							csntc(nick, "          \002:\002%s", cmds);
							cmds[0]='\0';
						}
					}
				}
			}
			if(cmds[0] != '\0')
			{
				if(premier)
				{
					if(level == 2)
						csntc(nick, "------------------[ \0036Commandes \002\0034Admins\003\002 ]------------------");
					else if(!level)
						csntc(nick, "------------------[ \0036Commandes \002\0033Users\003\002  ]------------------");
					else if(level == 5)
						csntc(nick, "------------------[ \0036Commandes \002\0032Salons\003\002 ]------------------");
					csntc(nick, "\002Niveau %3d:\002%s", level, cmds);
					cmds[0]='\0';
				}
				else
				{
					csntc(nick, "          \002:\002%s", cmds);
					cmds[0]='\0';
				}
			}
		}
	}
	csntc(nick, "Pour de l'aide sur une commande tapez \037/%s AIDE <commande>\037", parv[0]);
	csntc(nick, "Vous pouvez demander plus d'informations sur \002%s", bot.chan);
	return;
}
